# Changes API v2 to v3 Source: https://developer.voyado.com/docs/api/api-changes-v3 The current version of the Customer Engagement API has been upgraded to 3 to introduce new functionality, to make it easier to expand the API in the future, and to introduce more consistency. Here is a summary of the changes going from v2 to v3: * Consolidated and renamed endpoints for better experience and consistency * Moved some endpoints to the part of the API where they make more sense * Added the use of PATCH (update resource) and PUT (replace resource) methods * Corrected some field names that reflected legacy usage * Shifted more from header parameters to query parameters * New version of /orders endpoint with expanded functionality for storing, updating and segmenting on order data All existing usage of API v2 and v1 are not affected by these changes as those versions will now enter Active LTS (Long-Term Support). The v2 and v1 endpoints continue to be supported and may be used as before until further notice. Any errors found in these versions will be corrected as needed. Client developers are encouraged to use the current version of the API, version 3, for all new development and to upgrade existing functions, when possible, to make better use of all new functionality when it is released. Generally, new endpoints are only added in new API versions, as well as breaking changes. Non-breaking changes to existing endpoints may however be released within an existing version. See the API versioning model for details on how new API versions are released, how older versions are deprecated, and exactly how breaking and non-breaking changes are defined. Below are the detailed changes moving from v2 to v3. ## Orders The new **/orders** endpoints offer functionality to trigger an automation to send order communication (email or SMS) and also expanded functionality to store and update the order data which makes it possible to segment on order data. The v2 endpoint **/orders** only supports triggering an automation and will therefore be deprecated, however it may still be used as long as the v2 status is Active LTS. The integration pattern for **/orders** is changed to asynchronous, meaning you will be able to store data to be acted on independantly from the order data. New endpoint **/orders**. Use GET to all stored orders for a contact and POST to register a new order. New endpoint \*\*/orders/\[orderId} \*\*. Use GET to retrieve a single order, PUT to update an existing order and DELETE to delete the order permanently. New endpoint **/orders/\[orderId]/action**, used to trigger an automation and send order communication by email or SMS. New endpoint **/orders/jobs/\[jobId}** used to check the status of an order registration or update. ## Contacts Changes to the **/contacts** endpoints were done for better experience and consistency, moving some to other groups or changing the terminology for clarification of its function. The names of the **/contacts/\[contactId]/bonuschecks** endpoints (four of them) changed to */reward-vouchers* and some parameters and payload values have changed. See the "Reward vouchers (bonus checks)" section below. Endpoint **/contacts/\[contactType]/bykey/\[keyValue}** removed in v3. The same functionality is available from the */contacts/\[contactType]/bykey endpoint*. Endpoint **/contacts/count** removed in v3 (but is still available in v2). Endpoint **/contacts/\[contactType]/count** removed (but is still available in v2). Endpoint **/contacts/\[contactId]/bonuspointtransactions** removed in v3. Now point transactions for contacts are fetched by first getting point account ID using */point-accounts* and then using this ID in */point-transactions* to get the actual point transactions. The header parameters when creating a contact with **/contacts** are now query parameters. The header parameters when deleting a contact with **/contacts** are now also query parameters. Method when updating contact with **/contacts/\[contactId}** changed from POST to PATCH. The endpoint **/contacts/\[contactId]/transactions** changed to its own resource */transactions* and the contactId is now sent in the query string. More article data is returned in the response in v3. ## Contact overview Changes made to the payload for **/contactoverview**. The property "bonusPoints" changes name to "points" and "checkNumber" changes to "voucherNumber". In v3 a contact's total points (bonus points) are no longer returned from **/contactoverview**. This must now be done with a separate GET request to the already existing (but slightly changed) endpoint **/point-accounts**. ## Promote to member The v2 endpoint **/contacts/\[contactId]/promoteToMember** removed in v3. This was used to: * Update contact type to "member" * Set `isApproved` to true (triggering the "New Member" automation trigger Updating contact type is handled by */contacts/\[contactId]/updateContactType* in v3. Setting `isApproved` to "true" must be done manually in v3 using: ```http theme={null} PATCH /api/v3/contacts/{contactId}) ``` ## Preferences The individual endpoints used to update preferences were consolidated to the contact update. Endpoints **/contacts/\[contactId]/preferences/acceptsEmail**, **/contacts/\[contactId]/preferences/acceptsPostal** and **/contacts/\[contactId]/preferences/acceptsSms** removed in v3. Logic now handled by the update endpoint */contacts/\[contactId}*. ## Posoffers The **/posoffers** endpoints are obsolete and will be deprecated. Promotions should now be handled by the */promotions* endpoint. Endpoint **/contacts/\[contactId]/posoffers/all** removed in v3. Endpoint **/contacts/\[contactId]/posoffers/\[id]/redeem** removed in v3. Endpoint **/contacts/\[contactId]/posoffers/available** removed in v3. Endpoint **/contacts/\[contactType]/bykey/\[keyValue]/posoffers/\[id]/redeem** removed in v3. Endpoint **/contacts/\[contactType]/bykey/\[keyValue]/posoffers/all** removed in v3. Endpoint **/contacts/\[contactType]/bykey/\[keyValue]/posoffers/available** removed in v3. Endpoint **/contacts/bykey/\[keyValue]/posoffers/\[id]/redeem** removed in v3. Endpoint **/contacts/bykey/\[keyValue]/posoffers/all** removed in v3. Endpoint **/contacts/bykey/\[keyValue]/posoffers/available** removed in v3. ## Promotions Changes were made to the **/promotions** endpoints; Endpoint **contacts/\[contactId]/promotions** removed. To fetch a contact's promotions you can now use */api/v3/promotion-assignments*. Endpoint **/contacts/\[contactId]/promotions/\[promotionId]/redeem** removed in v3. For the same functionality use */api/v3/promotions/codes/\[promotionId]/redeem*. Endpoint **/contacts/\[contactId]/promotions/\[promotionId]/assign** removed and functionality replaced by */api/v3/promotion-assignments*. ## Points Changes were made to the **/point-accounts** section to clarify usage and consolidate endpoints. Parameters sent to **/point-accounts** in order to get a contact's points have changed. Note that, because of the changes to **/contactoverview**, the **/point-accounts** endpoint is now the only way to fetch a contact's points. Endpoints **/point-accounts/definitions** and **/point-accounts/definitions** are deprecated and should no longer be used. Endpoint **/contacts/rewardpointtransaction** no longer used, replaced by */api/v3/point-accounts/transactions*. Endpoint **/point-accounts/transactions** is not to be used and is replaced by */api/v3/point-transactions*. Endpoint **/point-accounts/transactions/\[id}** is not to be used and is replaced by */api/v3/point-transactions/\[id}*. ## Reward vouchers (bonus checks) Endpoint **/promotions/reward-vouchers/\[id]/reactivate** becomes */reward-vouchers/\[rewardVoucherId]/reactivate*. Endpoint **/contacts/\[contactId]/bonuschecks/\[bonusCheckId]/redeem** becomes */reward-vouchers/\[rewardVoucherId]/redeem*. Endpoint **/contacts/\[contactId]/bonuschecks** changed to */reward-vouchers*. Endpoint **/contacts/\[contactId]/bonuschecks/available** becomes */reward-vouchers/available*. Endpoint **/contacts/\[contactId]/bonuschecks/redeemed** becomes */reward-vouchers/redeemed*. The attribute **usedBonusChecks** is replaced by **usedRewardVouchers**. The attribute **checkNumber** is replaced by **voucherNumber**. ## Tracking and inventory Changes were made to the tracking and inventory sections to supports multiple items in a single request. Endpoint **/tracking/carts/batch** removed. Endpoint **/tracking/carts** enhanced to */tracking/carts* and can accept multiple items. Endpoint **/tracking/productviews** removed. Endpoint **/tracking/productview** enhanced to */tracking/productview* and can accept multiple item. Endpoint **inventory/stock-levels/batch** removed. Batch functionality now handled by enhanced version of */inventory/stock-levels*. ## Transactions / Receipts Endpoint **/transactions** used to import receipts is deprecated. In v3 use **/receipts** instead. The attribute **usedBonusChecks** is replaced by **usedRewardVouchers**. The attribute **checkNumber** is replaced by **voucherNumber**. ## Messages Changes were made to how historical email, SMS and postal messages are fetched for a contact. The single endpoint **/api/v2/contacts/\[contactId]/messages/latest** is replaced by three endpoints: * **/api/v3/contacts/\[contactId]/emailmessages** * **/api/v3/contacts/\[contactId]/smsmessages** * **/api/v3/contacts/\[contactId]/postalmessages** ## Other changes Endpoint **/memberstatus** removed in v3. # Non-functional requirements Source: https://developer.voyado.com/docs/api/non-functional-requirements When developing a client application that communicates with Customer Engagement using your tenant-specific API key, it's essential to follow certain non-functional requirements (NFRs). The guidelines listed here ensure that your integration is secure and resilient and aligns with Voyado's best practices. ## Security best practices ### Use HTTPS with TLS 1.2 or higher for encryption in transit All API requests must be made over HTTPS to protect data, including the API key, in transit. TLS ensures that credentials and payloads cannot be intercepted or tampered with during transmission. ### Store the API key securely at rest If your client needs to persist the API key: * Store it in a **secure secrets management system** (e.g., AWS Secrets Manager, Azure Key Vault). * Avoid hardcoding the key in source code, config files, or environment variables exposed to user-facing environments. * Use **file system-level encryption** and proper access controls if stored locally. * Never store the API key in frontend or browser-accessible code — all calls to the Voyado API must be made from trusted backend systems. ### Prevent exposure in logs or error messages Do not log the API key or include it in exception traces. Redact sensitive headers before logging outbound requests. ### Use the correct header-based authentication Send the API key in the x-api-key HTTP header, not in the URL or query string, to avoid accidental exposure via browser history or intermediaries. ### Implement IP Filtering Consider restricting API access for your tenant to specific IP addresses using Voyado's IP filtering feature. This adds an extra layer of security by ensuring that only requests from authorized IPs are accepted. ## Testing and environment readiness ### Use the staging Environment Before deploying to production, thoroughly test your integration in [Voyado's staging environment](/docs/introduction/staging-environment#about-the-staging-environment). Doing this allows you to: * Validate authentication and API connectivity. * Test all intended API endpoints, including handling of success and error responses. * Simulate various scenarios, such as network latency and API timeouts. * Ensure proper logging and monitoring are in place. ## Resilience and Error Handling ### Implement appropriate retry logic Your client should be able to handle temporary issues gracefully without overwhelming the API or duplicating requests unnecessarily. Retries should be performed **only under the following conditions**: * When server timeout (504) is received: This happens when processing the request taked too long. The timeout threshold is different for each endpoint, and is generally shorter for customer facing experiences. * **In the case of other 5xx server errors:** These indicate temporary issues on the Voyado side. It is safe to retry with exponential back-off. * **Connection timeouts or network interruptions:** These are transient connectivity issues can occur between your client and Voyado's API. * **There is a 408 (Request Timeout):** The server didn’t get the full request in time, often due to network delays. it is safe to retry with back-off, especially for idempotent requests. * **In the case of 429 (Too Many Requests):** The client is being rate-limited. Retry after a short delay using exponential back-off. **Do not retry** under these conditions: * **There is a 4xx client error that is not 408 or 429:** Errors such 400 (Bad Request), 401 (Unauthorized), 403 (Forbidden), or 404 (Not Found) indicate a problem with the request itself and will not succeed on retry without changes being made. * **There are invalid payloads or schema violations:** Fix the validation issues before retrying the same request. * **There are duplicate-sensitive POST operations:** Instead of blindly retrying, confirm whether the initial request succeeded (such as by using a GET) to avoid duplicating actions. ### Recommended strategy * Use **exponential back-off** with added jitter (random delay variation). * **Cap the retries** after a reasonable limit (such as 3–5 attempts). * Always **log retry attempts**, including reasons and delays. ## Monitoring and Logging ### Comprehensive Logging Maintain detailed logs of all API interactions, including: * Request and response timestamps. * Endpoint URLs and HTTP methods. * Status codes and error messages. This facilitates troubleshooting and performance monitoring. ### Monitor Performance Metrics Regularly track metrics such as: * API response times. * Error rates. * Request volumes. Monitoring these metrics helps in identifying and addressing performance bottlenecks promptly. ## Input Validation and Data Integrity ### Validate and Sanitize Inputs Ensure that all data sent to the API is properly validated and sanitized. This prevents malformed requests and potential security vulnerabilities.  ### Secure Data Storage If your application stores data retrieved from the API, implement appropriate security measures to protect this data, especially if it includes personal or sensitive information. ## NFRs for webhooks If your system subscribes to webhooks from Voyado Customer Engagement, your webhook listener must be designed for security, reliability, and scalability. ### Validate the source of incoming webhook requests Each webhook request includes an HMAC-SHA256 signature in the x-voyado-signature header, based on a shared secret. Your listener should compute the expected signature and compare it to the one received to verify that the payload genuinely comes from Voyado. This protects against spoofed or unauthorized requests. ### Use HTTPS and restrict access to the webhook endpoint Only expose your listener over HTTPS to ensure data is encrypted in transit. Restrict access to your webhook endpoint by allowing only traffic from Svix’s external delivery IPs — the service Voyado uses to send webhooks. While not required, this is strongly recommended to reduce the risk of unauthorized access. ### Support payload encryption if required If sensitive data is to be included in some webhook payload, you can configure your webhooks to use AES-256 encryption. Your system must then decrypt the payload on receipt using your private key. Note that encryption is either enabled for all webhooks or disabled entirely. ### Respond quickly and asynchronously Webhook endpoints should return a 200 OK response as soon as possible to acknowledge receipt. Any heavy processing (e.g., database updates or downstream API calls) should be handled asynchronously. This ensures reliable delivery and prevents timeouts. ### Implement rate limiting and queuing if needed If multiple events are sent in a short time (e.g., during peak campaigns), your listener should throttle incoming traffic and queue processing to avoid failures or overload. ### Log and monitor webhook activity Log incoming webhook events and responses, including timestamps, event types, and delivery status. Monitor for spikes, failures, or validation errors to ensure system health. # Working with the API Source: https://developer.voyado.com/docs/api/the-api Most of your work integrating your systems with Voyado Customer Engagement will involve its API. Calls to the API need to be made from server-side. Calls from client-side will result in a CORS (Cross-Origin Resource Sharing) error. Here you'll find a documented overview of the API: The current version of the API is 3. That is the one recommended for all new users. ## Liveness check The `/livez` endpoint provides a minimal check to verify that the Voyado Customer Engagement service is responding. ```http theme={null} GET /api/v3/livez ``` Or: ```http theme={null} HEAD /api/v3/livez ``` A response of *200 OK* is returned when the service is reachable and able to respond. This endpoint only verifies that the service can respond to requests. It does not perform checks against dependencies such as databases or external services. Requests to `/livez` count towards the standard rate limit of 200 requests per second per tenant. ## API overview These links will take you to sections in this article or to other articles. ## Base URL Voyado's APIs are accessed through a single base URL, made up of the client's name followed by "voyado.com". Use HTTPS for all interactions with the Voyado API For your production environment the base URL form is: ```http Production URL theme={null} https://[client].voyado.com ``` For the test (staging) environment the base URL form will be: ```http Staging URL theme={null} https://[client].staging.voyado.com ``` For example, a client named ABC123 would have this base URL in the staging environment: ```http theme={null} https://abc123.staging.voyado.com ``` And this URL in production: ```http theme={null} https://abc123.voyado.com ``` ### Naming convention In this documentation, the part of the URL that comes before /api will be left out and the HTTP method will be added before it. For example, instead of an instruction to make a GET request to: ```http theme={null} https://abc123.staging.voyado.com/api/v3/contacts/{contactId} ``` You will just see this in the documentation: ```http theme={null} GET /api/v3/contacts/{contactId} ``` ## Authentication The API key provides you access to the Voyado Customer Engagement API. As with all keys, it needs to be handled carefully so it doesn't fall into the wrong hands. ### Authorization method The authorization method `apikey` is used, as part of a HTTPS header. ### User Agent In order to track where an API call comes from, and which version the customer is using, the "User-Agent" request header should be used in all calls made to the Customer Engagement API. This provides valuable data, improving service and allowing better and faster support for you if problems occur. "User-Agent" is set as a HTTPS header, stating the system and which version of the integration the customer has. For example, if the client Acme is using a POS called "Acme-POS" with version 1.5, the "User-Agent" value in the request should be something like "AcmePOS/1.5". While the "User-Agent" request header is highly recommended for all API calls, no error will occur if it is omitted. ### Content-type In all request made to the Customer Engagement API, it's mandatory to use "Content-Type: application/json". This needs to be sent in the HTTPS header in the API-call. If it's not included, or some other `Content-Type` is used, such as "text/plain", Customer Engagement will return a 500-error with the message “An error has occurred”. The following example will return a *200 OK* response assuming the connection to Customer Engagement is working. ```bash theme={null} curl -i "{your-base-url}/api/v3/livez" \ -H "User-Agent: AcmePOS/1.5" \ -H "apikey: {your-api-key}" \ -H "Content-Type: application/json" ``` The `Content-Type` header in all requests to the API must be "application/json" for your request to work. ## Rate limit In order to maintain a high quality of service throughout the system, Voyado recommends that you keep the frequency of your requests to the Voyado Customer Engagement API below 50 per second under normal operation. If you exceed the rate limit of 200 requests per second, the API will return a HTTP-status code [**429 Too Many Requests**](https://developer.mozilla.org/en-US/docs/Web/HTTP/Status/429). Going above the API limit recommendations for more than a few seconds can cause degradation in Voyado's services. Rate limits are measured **on the tenant level** and not per API key. ## Retry policy As a user of the Voyado Customer Engagement API, you must always ensure that, after sending a request, your solution waits for the response to arrive. If a response is delayed, you should not perform a retry before you know the reason for the delay. Always wait for a response from the Customer Engagement API before trying again. If your response is late, it is more probable that Customer Engagement is under an unusually high load and responding slowly than your message was lost along the way. Messages can be lost, of course, but it is not the most likely scenario. According to the Voyado Customer Engagement [integration principles](/docs/integration/about-integration#integration-principles), a contact should always be able to perform their entire purchase in the POS or e-com, regardless of problems such as the Customer Engagement API not responding. The internet is complex and many things can go wrong or be delayed. So if your flow is time-critical, you should be prepared to handle all likely interruptions on your end, and not be entirely dependent on ideal-case response times from Customer Engagement. ### Timeouts Customer Engagement's general stance is that delays are beneficial. The platform is designed to prioritize successful execution over speed, particularly to avoid data corruption. As such, most API endpoints are configured with long timeouts; this gives clients the best chance of receiving a response without prematurely failing the request. It is therefore not recommended that customers enforce their own timeouts. However, in critical flows, such as Create Contact, where the API interaction is tied directly to customer-facing experiences (e.g. onboarding confirmations), there is a need for quicker client feedback. In these specific cases, Customer Engagement may proactively return a timeout with a shorter interval, using the status code "504 RequestTimeOut". The exact timeout duration is not specified but might be indicated per endpoint both in this documentation and in the endpoints/developer overview. ### Retrying If a retry is unavoidable, here are a few things to keep in mind: In general, a retry should be made as late as possible based on your particular scenario. Shorter retry intervals can make the problem worse, increasing the possibility of writing incorrect data, as well as the load on the system. But it also depends on what you're doing. For example, a job started by a server or process on another system can wait increasingly long intervals between retries (10s, 30s, 60s, 300s, etc.) whereas an action invoked by a user (such as a call from POS, e-com or the web) can get away with a shorter wait before a retry is made. But, again, wait as long as possible before retrying. POST requests change the state of the system every time they are called. So retrying a POST request without knowing if the first one went through can be very dangerous. It's always wise, when retrying a POST, to: * Wait as long as your particular scenario allows * Check using a GET if your previous request went through or not * Try another POST, at increasing intervals The basic advice is to be ready for this when it happens and to follow the integration principles: ### Jitter It can be a good idea to add some jitter when performing retries. Jitter is some randomness added to your retry schedule so that every client is not calling the system at the same time and reducing its performance. For example, if your retry schedule is the following: * Retry Immediately * Then after 5 seconds * Then after 5 minutes * Then after 30 minutes Just do the following before each request: ```csharp theme={null} func sync() { // instead of immediately performing the call // we add jitter to distribute the network load val jitter = random(0.5, 1.5); wait(jitter.to_seconds); perform_network_request() } ``` ## Security For the majority of customers, interacting with the Voyado API is central to their solution, enabling them to create, read, update and delete information in multiple contact's journeys simultaneously. As a Voyado customer, you can freely access your data in real time. However, this comes with certain risks, since that information could possibly end up in the wrong hands. To mitigate these risks it's imperative that all users of the Voyado API do their best to handle their traffic in the most secure way possible. This section will list the basic measures that all API users should implement. ### API key in query string The usage of an API key in the query string of an incoming request is NOT considered safe. Such a request is not strictly a security issue in itself, provided encrypted traffic is used. The problem is that the request, on its way from point A and point B, is most likely logged by the servers handling the traffic. The whole query string will then be visible in those logs, making them a potential security issue. API keys, because of this, should **not** be used in the query string but only in the header of the request. ### Encryption of data Users of the Voyado API must adhere to common practices regarding encryption of traffic. We adhere to Mozilla's definition of Intermediate Compatibility. HTTPS should always be used when communicating with the Voyado API to guarantee basic security. ### TLS Starting **October 1, 2025**, Voyado will only support **TLS 1.2 or higher**. The older standards, TLS 1.0 and TLS 1.1, are considered insecure and will no longer be accepted. Any requests using non-supported TLS versions will be denied. ### IP filtering with API keys It is possible to restrict access to the Voyado API for a specific API key using IP-filtering. This measure, set up by Voyado, limits access to traffic coming from specific IP addresses or ranges of IP addresses, greatly reducing the risk for leakage of data. In the case of an API key becoming compromised, an attacker would then also need access to a device/service communicating through the correct IPs to gain access to the data, providing an extra layer of security. The API key on its own is not enough to provide access. ### Recommended ciphers * ECDHE-RSA-AES128-GCM-SHA256 * ECDHE-ECDSA-AES256-GCM-SHA384 * ECDHE-RSA-AES256-GCM-SHA384 * ECDHE-ECDSA-CHACHA20-POLY1305 * ECDHE-RSA-CHACHA20-POLY1305 * DHE-RSA-AES128-GCM-SHA256 * DHE-RSA-AES256-GCM-SHA384 ## Versioning strategy API versioning is the practice of managing changes to an API and ensuring these changes are made without disrupting clients. A good API versioning strategy clearly communicates the changes made and allows API consumers to upgrade to the latest version at their own pace. Voyado's API versioning model for Customer Engagement is designed to enable their developer teams to release new and changed functionality that extends the API in a controlled way. The new model gives Voyado's client\`s developers (both partner and in-house) improved and updated documentation, including well-defined release notes for all changes to the API. The model ensures that Voyado's client developers (both partner and in-house) always get updated documentation, including well-defined release notes for all changes to the API. ### The Customer Engagement API today * The current version of Customer Engagement API is version 3 * All versions of the API can be used independently * A common API versioning scheme is used for all endpoints * Major version upgrades are done when breaking changes are needed (see below) * Minor non-breaking changes are done regularly * V1 is considered deprecated but can still be used ### Definition of changes The definition of what is a breaking and a non-breaking change is vital in understanding the Customer Engagement API versioning strategy. The following are examples of **non-breaking changes**: * Adding an optional field to a request message. Existing client code will not be forced to use the new field. * Adding a required field with a default value to a request message. The server will add the default value if the client does not send it. * Adding a field to a response message. Existing client code should ignore any such new fields. Clients should not implement a mapping that raises an error for new fields. These are examples of **breaking changes**: * Renaming fields or resource paths in a way that requires client code to change. * Renaming or removing fields in a request or response message. * Removing API operations used by existing clients of the API. * Changing fields from single value to multiple value (like from a single email per member to a list of email addresses). * Changing the HTTP method or the response codes returned by an API operation. Code accessing our API should not break if an API endpoint starts to return responses containing additional fields. Such changes could be made by Voyado without warning as part of our normal development so you need to be ready for them. Breaking changes will be flagged early, giving you adequate time to prepare. ### The API versioning vision The Customer Engagement API should be **reliable**, **scalable** and **easy to use**, providing clients with real-time access to their core CXM environment. There are four key goals: Voyado's developers must be able to release new or changed endpoints to production whenever they are ready. This will work like this: 1. Non-breaking changes will be developed and released continuously to production by Voyado's teams following the normal release process. 2. Breaking changes (that trigger a new version) will also be released continuously but will be hidden behind a feature toggle. 3. Breaking changes should be collected into official releases, ensuring consistent communication both externally and internally. 4. First-mover clients may be selected to use pre-released API functionality before official releases, although with limited support. To ensure backward compatibility: 1. Voyado will not force clients to upgrade their API version, and will avoid impacting working integrations by keeping multiple supported versions in parallel. 2. Voyado will warn well in advance before moving a version to an unsupported end-of-life state, giving clients time to upgrade. 3. Voyado will deprecate versions in a controlled manner, and have a dialogue with clients still using unsupported version to help them upgrade. Voyado will ensure clear communication and up-to-date documentation. * New versions with breaking changes will require all related API documentation to be updated and clear release notes to be communicated both externally and internally. * Minor non-breaking releases will also require changes to API documentation as well as clear release notes. Voyado will be as transparent and consistent as possible with API roadmaps and release notes. * Voyado will publish and communicate the new API versioning model externally to partners and clients. * Voyado will communicate the new API version strategy and versioning model to all Voyado departments. * Voyado will train their dev teams to use the new API versioning model. The goal is for new functionality to only be released in the current API version, to minimize maintenance but also to give our clients an incentive to upgrade to the latest version, increasing the number and quality of features they have available to them. However, an older API version could sometimes be updated to use newly released code if that simplifies overall code maintenance. ### API release status These are the lifecycle phases for an API version: Graph showing API lifecycle phases for different versions **Limited:** Only accessible by selected clients (used in development). **Current:** The latest release. New releases will be introduced regularly, but there is no fixed release schedule. **Active LTS:** Long term support. There is no set time limit, it depends on the support cost and how much that version might limit development. **Deprecated:** A version not supported but still active. Clients are notified at least 6 months in advance if a deprecated version is to be moved to end-of-life. **End-of-life:** This version is not supported. It may be deleted or redirected to a newer version. It will be removed when not used by any client. ### Strategy in a nutshell These are the important points of the Customer Engagement API versioning strategy: 1. Versioning will be separated on an application level (Customer Engagement, Product Discovery Storefront, Product Discovery Admin). 2. A single version will be used for all Customer Engagement API endpoints. 3. A new API version will be released when breaking changes are introduced. 4. An old API version will be supported for at least 18 months. 5. Non-breaking changes will be automatically applied to the latest version. API versioning in Customer Engagement is not connected to the API versioning in Product Discovery. # Timeout changes API v3 Source: https://developer.voyado.com/docs/api/timeout-changes This is information about a timeout change to the Customer Engagement API, posted 2025-04-10. ## Create contact endpoint This section concerns data posted to the following endpoint: ```http theme={null} POST /api/v3/contacts ``` This endpoint will now enforce a shorter timeout, and will return a "504 RequestTimeOut" status code if a response does not come within about 5 seconds. This is designed to provide more timely feedback in customer-facing flows, such as user sign-ups and onboarding, where quick responses are critical for a smooth experience. If Customer Engagement returns a timeout status code for this endpoint when a request is made, it means that no contact has been created, and all related internal operations will be rolled back. If this happens, the integrating system should then retry the request in accordance with the Customer Engagement [retry policy](/docs/api/the-api#retry-policy). At this link you will find guidance on the recommended retry strategies. This change is only for *API version 3*. Version 2 will function as it previously did. ## Redeem promotion endpoint This concerns the following endpoint: ```http theme={null} POST /api/v3/promotion-assignments/{assignmentId}/redeem ``` A similar timeout policy has already been implemented for this endpoint. A request will time out after approximately 4.5 seconds unless the promotion has already passed the "point of no return" (which means it has been marked as redeemed). ## General policy for timeouts Customer Engagement's general approach is to prioritize successful processing over speed. Most API endpoints are therefore configured with long timeouts to reduce the risk of data corruption. In general, custom client-side timeouts are discouraged unless absolutely necessary. If you have any questions about how this change may impact your integration, or would like help adjusting your implementation, reach out to your support team. # UICulture and localization Source: https://developer.voyado.com/docs/api/uiculture-localization Culture (in the context of software) refers to how culture-dependent data such as dates, currencies and numbers are both presented and interpreted as input. An example is whether "." or "," is to be used for the decimal separator and the thousands separator. UICulture refers to which locale-specific external assets are to be loaded in. In the case, it's the language of the texts shown in Customer Engagement. By default, these texts are sent in Swedish, because Voyado's servers are configured with that locale. In normal website requests, the text language is determined according to the user's settings, which are saved in a cookie in the browser. Using cookies is also possible for backend/API calls, but it is not standard. There is, however, a way to be sure of which translations are delivered, regardless of other settings: the UICulture parameter. By adding `?UICulture=en-GB` to the query string of your API call when requesting the texts, you can be sure they will be sent to the client in English. For example: ```http theme={null} https://demo.staging.eclub.se/startdata/localization?UICulture=en-GB ``` If your call contains a `UICulture` parameter that is not valid, English texts will be returned as this is the translation engine's default. To force translations to be returned in a specific language, use the `UICulture` parameter. # E-com and communication Source: https://developer.voyado.com/docs/communication/communication Here we cover the tracking and communication possibilities in Customer Engagement. ## E-com and tracking Captures customer interactions on your e-com and connect them to a customer profile in Customer Engagement. * **Web activity tracking** records on-site behavior such as product views and cart activity * **Onsite messaging** allows targeted messages and campaigns to be displayed directly within the e-commerce experience * **Back in stock** enables customers to subscribe to stock updates for a specific product and triggers notifications when items are restocked ## Campaigns Learn about email, SMS and postal send-outs in Customer Engagement. Read about: * Email deliverability * Bounced and unsubscribed * Sending SMS messages * Using external content * Suggested products For how to create and localize emails for your audiences, see the Help Center: # Introduction to contacts Source: https://developer.voyado.com/docs/contacts/about-contacts A *contact* in Voyado Customer Engagement is the unique collection of data connected to an individual customer. You can't store transactions or other event data without connecting it to a specific contact. During a contact's journey, the amount of information connected to them increases with every step. When working with the contacts API, and all other Customer Engagement API endpoints, it is important to keep the API rate limits in mind to avoid degraded service. ## Contact types To track as much information as possible as a contact progresses from an unknown web user to a loyal customer, Customer Engagement uses contact types. This allows a unique data model for each phase. A contact type's name is a [handle][handle] that refers to a specific data structure. A contact type also has a display name which will be used in the UI. These display names must not be the same as the handle. The handle "Member" always exists when a Customer Engagement environment is created. The handle "Contact" is often added too. You can also add other user-defined contact types. * **Member:** This usually has the richest data model, where the person has given their consent and shared their information. This can sometimes be called "Customer" in the UI. * **Contact:** This is mainly used for email lists such as "Newsletter subscribers" or "Prospects". Typically this contact type contains only an email and some demographic data such as a country code. Sometimes "Member" is the only contact type, and sometimes both "Contact" and "Member" will exist. Other custom contact types can be added to suit the customer's specific needs. The relevant contact types, along with their key values and mandatory fields, are defined in the client project and can be obtained from your Voyado Customer Engagement team. The contact card in the Customer Engagement UI ## Data model The amount of data connected to a contact type - the type's *data model* - can be adjusted depending on your needs. Voyado and its partners can configure which fields are included and can also add custom fields in the formats listed here: ## Public identifier For every contact, one or more public identifiers are defined. This is unique data for every individual that can be used to identify them in a sales interaction. A mobile phone number is often used as a public identifier. In Sweden a person's unique *Public Identity Number* is sometimes used. A pure player (e-commerce) will probably use email, but email is not really the best identifier in a physical store scenario, where information needs to be given quickly and correctly. Multiple lookups on different identifiers can be done on a POS system. The lookup fields used can also vary from installation to installation. ## Integration key The integration key is used to link a customer to their interactions, most commonly through transactions. It is strongly advised to use a unique numerical value such as: * **contactId:** The contact's unique identifier in Customer Engagement * **memberNumber:** The value connecting a point transaction to a contact * **externalId:** The contact's unique identifier in an external system By doing it this way the data stored for a transaction can’t be linked to an individual in XML files or to API calls outside of the Voyado Customer Engagement context, increasing privacy [handle]: https://en.wikipedia.org/wiki/Handle_\(computing\) # Bulk contacts API Source: https://developer.voyado.com/docs/contacts/bulk-contacts-api The bulk contacts endpoints are used for batch updating of contact data directly over the Customer Engagement API. ## Bulk reading of contacts You can get an array of contact IDs of all contacts that have been changed (created, updated or deleted) within a specified time window using this endpoint: ```http theme={null} GET /api/v3/contacts/changes ``` This endpoint takes three parameters: Created, Updated, Deleted The start date and time of the search window. The end date and time of the search window. If `toDate` is left out of the query, the current date and time will be used. For example, assuming the date and time now is "2023-05-04 11:20:00.000" and you want the IDs of all contacts created over the last 15 minutes, the request would be: ```http theme={null} GET /api/v3/contacts/changes?changeType=Created&fromDate=2023-05-04%2011%3A05%3A00.000 ``` ### Response The response will look like this: ```json All contacts changed within the given window theme={null} [ "b16fd8f3-d0f5-aaaa-aa60-b00300f9aaaa", "febb6003-863d-bbbb-a4d0-b0030119bbbb" ] ``` Or, if there are no contacts matching your search, an empty array: ```json theme={null} [] ``` The number of contactIds that can be returned in the response is currently capped at 250 000. If your query creates a response that exceeds this limit, it will instead return a Bad Request status code. ## Bulk writing of contacts To create multiple contacts at once, the contacts bulk API endpoint can be used: ```http theme={null} POST /api/v3/contacts/bulk ``` You can also use this same endpoint to update multiple existing contacts at once: ```http theme={null} PATCH /api/v3/contacts/bulk ``` The maximum number of contacts allowed in one bulk request is 4000. The rate limit for this endpoint is the same as for other endpoints. If you are planning to do a large migration of contacts, and you have an XML export activated, first get in touch with your Voyado team. ### Query string parameters There are two optional parameters that can be added to the query string: This prevents your bulk contact request from triggering the automatic BI and XML contact exports. The default value for this attribute is "false" so you only need to include this if you want it to be true. You can read more about this parameter here. This allows you to specify the contact type of the contacts you are creating (or updating). If not specified, your default contact type configured in Customer Engagement will be used. The `avoidTriggeringExport` parameter only has an effect when doing a bulk update (that is, when using the PATCH operation). A request using these parameters (a bulk update in this case) would look like this: ```http theme={null} PATCH /api/v3/contacts/bulk?avoidTriggeringExport=true&contactType=Contact ``` In this example, all the contacts updated will be of `contactType` "Contact". ### Creation payload The data needed to bulk create contacts has the same requirements as when creating an individual contact using the `contacts` endpoint. This means, at a bare minimum, that the key attribute must be included in the payload (in this case, it's `email`). Here is a basic bulk creation payload: ```json Basic bulk contact creation payload theme={null} [ { "firstName": "Anna", "lastName": "Arkberg", "city": "Examplecity", "email": "anna@example.com", "registrationDate": "2022-01-01T00:00:00+0100" }, { "firstName": "Berit", "lastName": "Berlucci", "city": "Examplecity", "email": "berit@example.com", "registrationDate": "2022-01-01T00:00:00+0100" } ] ``` If you have specified a `contactType` in the query string then all these new contacts will be created with that type. If it's not specified, the new contacts will all be created using whatever default `contactType` you have configured in Customer Engagement. ### Consents and preferences There is an important difference between creating contacts individually with the `contacts` endpoint and creating them in bulk using the bulk endpoint discussed here. In the bulk API case, the contact data is sent "flat", as can be seen here for these two contacts: ```json Flat JSON structure for bulk contact creation theme={null} [ { "firstName": "Anna", "lastName": "Arkberg", "city": "Examplecity", "email": "anna@example.com", "acceptsEmail":true, "acceptsPostal":false, "acceptsSms":false, "memberConsent":true }, { "firstName": "Berit", "lastName": "Berlucci", "city": "Examplecity", "email": "berit@example.com", "acceptsEmail":true, "acceptsPostal":false, "acceptsSms":true, "memberConsent":false } ] ``` Note that here `memberConsent` is sent as an attribute and a value, not as an object. In Customer Engagement, this consent's `date` attribute will be the date of the bulk import and the `source` will be set to "Import". However in the case of the single-call endpoint `/api/v3/contacts/{contactId}` the "consents" and "preferences" values are always sent *as object arrays* as can be seen here: ```json JSON structure for single contact creation theme={null} { "firstName": "Anna", "lastName": "Arkberg", "city": "Examplecity", "email": "anna@example.com", "preferences": { "acceptsEmail": true, "acceptsPostal": true, "acceptsSms": true }, "consents": [{ "id": "memberConsent", "value": true, "date": "2022-01-01T00:00:00+0100", "source": "ECOM", "comment": "Approved member terms at checkout" }] } ``` In Customer Engagement, the consents `acceptsEmail` and `acceptsSms` should not be changed from "true" to "false" unless the contact has actively opted out of communication, for example through My Pages or by unchecking a pre-selected opt-in during checkout. ### Update payload When doing a bulk update through the API, you will need to specify the unique contact ID for each contact, along with the value or values you want to change. Sending null or empty values of fields in an update payload can have unpredictable results. Sometimes the current value will be overwritten, depending on the field type, and sometimes not. In general, do not send null or empty values unless you explicity want to change the field to that value, and even then it's best to confirm the results first. ```json Bulk contact update theme={null} [ { "contactId": "a9cc2989-6a39-4168-b48d-afda77a0139c", "lastName": "Berg", "city": "Exampelopolis" }, { "contactId": "4823f5ab-9d03-41d2-ae1f-afda99a013cb", "lastName": "Ek", "city": "Exampelholm" }, { "contactId": "8afa642d-d4e2-4040-a573-2dc20ea6b9a0", "lastName": "Sten", "city": "Exampelholm" } ] ``` All items in a bulk contact update must have the same properties, as seen in the example above. If they don't, a *HTTP 422: Properties differ between contacts* error will be thrown and you risk some contact data becoming overwritten with empty values. All contacts sent in a bulk update must have the same `contactType`. You either send this in the query string, or else not specify it and the default value will be used. This means you **cannot** mix contacts of different `contactType` in the same bulk update request. ### Full update payload example Here is a full update payload with all the contact attributes you can send. In practice, you'll rarely send all of these attributes at once in a contact update, and will just be updating some of them. The complete list shown here is just for reference. ```json Full update payload example theme={null} [ { "street": "Example Avenue 12", "lastName": "Person", "firstName": "Test", "zipCode": "string", "careOf": "careOf", "city": "Examplecity", "countryCode": "SE", "consent": "true", "acceptsEmail":true, "acceptsPostal":false, "acceptsSms":false, "email": "test.person@test.com", "mobilePhone": "+46700111222", "age": 65, "birthDay": "2004-04-11", "gender": "Female", "socialSecurityNumber": "190703316893", "discoveryKey": "87bd3b56-a1fd-4060-9962-4f08ef047251", "lang": "en", "currentStoreExternalId": "SE", "labels": "Label1,Label2" } ] ``` ### Responses If your request has been successful, you'll get a *202: Accepted* response. Your data is now ready for processing. A unique batch ID for your request will also be returned as a GUID. Save this batch ID as you'll need it to check the status of your batch job. If the request has not been successful, you'll get one of the following HTTP error codes: * *422: UnprocessableEntity* * *503: ServiceUnavailable* ### Status Your batch job can take time to be processed. You can check the current status of the job by calling this endpoint with the batch ID: ```http theme={null} GET /api/v3/contacts/bulk/status?batchId={batchId} ``` This returns an object containing a `status` attribute with one of these values: * **Received**: Your payload has been received. * **InProgress**: Processing of your data is in progress. * **Done**: Your contacts should now be created / updated. * **The request is invalid**: The batch ID you sent could not be found. * **Error**: There was an error. The progress of your batch will be recorded in the integration log. Batch process in the integration log The log is especially useful when finding out what happened if things go wrong. ### Starting the job Once you get back a status of "Received" your data is ready to be processed. This happens on a schedule, so it might not be completed right away. Keep polling the `status` endpoint to see when it's done. ### Wrong contact type If a bulk update contains a contact of the wrong `contactType`, updating of that contact will be skipped and the job will continue. ### Contact that already exists If a bulk create contains a contact that already exists in Customer Engagement, the existing contact will be not be changed and the job will continue. In the same way, if a bulk update refers to a contact that does not exist, that row will be skipped and the job will continue. # Contact field definitions Source: https://developer.voyado.com/docs/contacts/contact-field-definitions The fields (attributes) listed here are created by default for every contact type in Voyado Customer Engagement. ## Contact standard fields These contact attributes exist by default when setting up a new Customer Engagement tenant and every contact created will have them. | **Field name (UI)** | **DB name** | **Field type** | **Description / example value** | | :- | :- | :- | :- | | Contact type | contactType | String | The contact type for this contact, such as "Member" or "Contact" | | First name | firstName | String | Example: Jane | | Last name | lastName | String | Example: Doe | | Member Number | memberNumber | Sequence | Example: 12345678 | | Social Security Number | socialSecurityNumber | SocialSecurityNumber | Validation requires this to be either a Swedish personal identity number, a Finnish personal identity code or a Swedish samordningsnummer. If only 10 digits are specified it is assumed the contact is less than 100 years old. | | E-mail | email | Email | Example: [jane@doe.com](mailto:jane@doe.com). | | Mobile Phone | mobilePhone | PhoneNumber | Example: +4612345678. Country calling code is required (+46) | | Registration store | createdInStore | SingleStorePicker | Example: 1001. Once this is set it can't be updated | | Regular store | store | StorePicker | Example: 1002. If not set then this defaults to the same value as Registration store | | Street Address | street | String | Example: Janes street 12 | | Zip Code | zipCode | String | Example: 123 45 | | City | city | String | Example: Stockholm | | Care Of | careOf | String | | | Country | country | String | Example: Sweden | | Weighted RFM (1-100) | rfm | Number | Calculated and set in Customer Engagement | | Recency (1-5) | retail.keyvalue.recency | Integer | Calculated and set in Customer Engagement | | Frequency (1-5) | retail.keyvalue.frequency | Integer | Calculated and set in Customer Engagement | | Monetary (1-5) | retail.keyvalue.monetary | Integer | Calculated and set in Customer Engagement | | Age | age | Integer | Example: 28. Automatically set if socialSecurityNumber or birthDay is populated. | | Birthday | birthDay | BirthDate | Given as YYYY-MM-DD. Example: 1963-02-13 | | Gender | gender | Gender | Customer Engagement allows four options: Male, Female, Other, PreferNotToSay (as well as NotSet when no value has been chosen). | | Nps-grade | nps.grade | Integer | Set by Customer Engagement | | Nps-date | nps.datetime | DateTime | Set by Customer Engagement | | Average Nps-grade | nps.averagegrade | Number | Calculated in Customer Engagement | | External ID | externalId | String | Identification key from external systems. Used when Customer Engagement isn't the master. | | Country Code | countryCode | CountryCode | As [ISO 3166-1 alpha-2](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2) Example: SE | | Language | lang | Language | Contact's preferred language from the [ISO 639-1](https://en.wikipedia.org/wiki/List_of_ISO_639_language_codes) list (en, sv, de, nb). A filtered version of this list can be configured in the Customer Engagement back-end so that only the values you want to include are shown. | | Registration date | registrationDate | DateTime | Valid date format is ISO 8601 with time zone designator (e.g. 2021-01-26T15:10:17+01:00) | | Source | source | String | "ECOM", "API", "STORE" ... | When creating a contact, the recommended approach is to ONLY specify `countryCode` in the payload. The value for `country` will be automatically populated based on what you specify for `countryCode` (assuming you have sent a valid value). So do *not* include `country` in the payload. ### More about Birthday Customer Engagement automatically calculates if the current day is the contact's birthday, based on the standard contact attribute Birthday. This is the only way it is done. If birthday or age is added as an extra field, they will be ignored. The Birthday calculations that activate the trigger are made every morning at a random time between 6:00 and 8:00. `Birthday` must have the format **YYYY-MM-DD** with dashes as shown. Using an incorrect date format when creating a contact will *not* stop the contact from being created, but it will cause their Birthday to be null. ## Contact custom attributes As well as the standard contact attributes listed above, there is also the option to extend the data model by adding custom contact attributes, based on the client's needs. Custom attributes can be used to store data about contacts in order to create useful segments or to personalize content in send-outs. Both standard and custom contact attributes use the field types listed in the section below. ## Contact field types Below are the field types supported in Customer Engagement and their constraints: * **Text** - Standard string field * **Long text** - Extended text field * **Number** - Decimal field * **Checkbox** - One checkbox * **Checkbox (multiple)** - Several checkboxes * **Dropdown menu** - A dropdown menu * **Social security number** - The attribute `socialSecurityNumber` is a default attribute of this type. It is possible to add another social security number field as long as both fields don't set birthday and gender.  * **Store (current)** - The store (current store) field will be automatically added when activating the "Stores" module in "Enable/disable modules". Adding another attribute of this type is not recommended, and if you do then both fields will be mirrored, meaning that changing one will automatically change the other. * **Store (created in)** - See "Store (current)Company (only with Company-module) - *DEPRECATED* * **Birth date** This is type BirthDate and always given as YYYY/MM/DD, for example **1971/05/26** * **Date and time** - For other dates and times we use [ISO 8601](https://en.wikipedia.org/wiki/ISO_8601)  * **E-mail** - We validate email according to: **RFC 5322, adr-spec** * **Formula** - (Used in special cases) * **Gender** - The gender attribute is a default attribute of this type, and it can be calculated by either socialSecurityNumber (default), setting on the socialSecurityNumber attribute. * **Integer** - Maximum length of this field is 12 digits. * **Sequence** - Serial number, for instance **memberNumber**. When manually importing contacts the sequence attribute (memberNumber for instance) needs to be present but empty for Customer Engagement to set a sequence number. * **List of children** - It's possible to add multiple children with their age set by their birth date. * **Country** This is of type countryCode - ISO 3166, Alpha-2 (two digits). * **Consent** - The consent attribute includes title, linked text and the actual terms text (HTML). * **Age** (Integer) - Is set by socialSecurityNumber by default. When using the type Sequence as a custom attribute, it should never be used as a key since this will impact performance severely. You will never need to manually create any fields of the following types, since one of each is created by default whenever a contact is created, and duplicates are not allowed: * Store (current) * Store (created in) * Birth date * Gender * Age (integer) ## More about standard fields ### Mobile Phone (mobilePhone) Each contact can only have one phone number connected to them, and the number should always be formatted as MSISDN (Mobile Station International Subscriber Directory Number), as a "+" prefix followed by \[countrycode]\[phonenumber]. For example: +46707104603. Voyado Customer Engagement uses [libphonenumber](https://github.com/googlei18n/libphonenumber). a Google open source library, to validate phone numbers internationally. For a deep dive into the area of phone number validation and all the issues that can occur, [you can read this page](https://github.com/googlei18n/libphonenumber/blob/master/FALSEHOODS.md). The library libphonenumber works by setting a "default" country code, from which all numbers are validated. A number is considered valid if you, by calling that exact number from a phone in the "default" country, could succeed in placing a call. However, this can quickly become complex, making it important to follow the standard. Consider these cases: **Case 1**: If the default country is SE, the following numbers are valid: 0707104603, +46707104603, 0046707104603. This is because "00" is the international calling code from Sweden. **Case 2:** If the default country is US, the same number, 0046707104603, would now not be valid, since "00" is not an international calling prefix in the US. So, although it will sometimes work, you should never send phone numbers using only the country code (without prefixing "+"). There are many ambiguities where it is impossible to distinguish a country code from a regional code. For example, 468211415 will be validated as a number with regional code 046 (Lund) instead of a Swedish number (46) if called from regional code 08 (Stockholm). Thereby it will be stored in the database as 46468211415. Similar things can happen with Norwegian numbers that have country code 47, but local numbers may themselves also start with "47". A phone number should always be made of a "+" prefix followed by \[countrycode]\[phonenumber]. Using "local" phone numbers based on the default country code should only be done when manually entering phone numbers in Customer Engagement, i.e. when searching, or using the LoyaltyBar, or on registration forms. ### Email (email) All emails in Customer Engagement are validated according to *RFC 5322, addr-spec*. Read the details of [RFC 5322 here](https://www.rfc-editor.org/rfc/rfc5322). Read a [general explanation of email standards here](https://en.wikipedia.org/wiki/Email_address). ### Country code (countryCode) Country codes follow the ISO 3166, alpha-2 naming standard. Some useful examples are: * SE = Sweden * NO = Norway * GB = Great Britain (and Northern Ireland) * NL = Netherlands * IE = Ireland ### Language (lang) Some markets / countries use multiple languages, for example Belgium, where Dutch and French are both used. Here, the countryCode contact attribute isn't enough to identify the end-user's language. In cases like this, the lang (language) standard contact attribute can be used. The lang contact attribute is of type Language, and follows the [ISO 639-1](https://en.wikipedia.org/wiki/List_of_ISO_639-1_codes) standard. Examples: * en = English * sv = Swedish * nb = Norwegian (bokmål) * de = German Since the list of languages is very long and can be troublesome to navigate when manually setting a contact's language, a custom-made shorter version of the list can be configured for your tenant, showing only the languages you intend to use for your contacts. Contact your Voyado team to do this. ## Preferences and accept flags A contact also has several optional preference fields defining how they wish to be contacted, known as accept flags. | **Field name (UI)** | **DB name** | **Field type** | **Description & example value** | | :- | :- | :- | :- | | Accepts Email | acceptsEmail | Bool | True / False | | Accepts Postal | acceptsPostal | Bool | True / False | | Accepts SMS | acceptsSms | Bool | True / False | If these accept flags are used, they must be set to either true or false, and never to null. # Create contact Source: https://developer.voyado.com/docs/contacts/create-contact A vital part of any Customer Engagement integration journey is registering new contacts. This is done using the following endpoint: ```http Creating a contact theme={null} POST /api/v3/contacts ``` This endpoint can be used to create a contact with `contactType` of "Contact", "Member" or any of your custom types. You will need to provide the mandatory fields for your specific contact type along with whatever key value you have specified in your configuration. That will be one of the following: * **mobilePhone** * **email** * **externalId** * **socialSecurityNumber** (Swedish or Finnish personal identity number) An important change when moving from API v2 to v3 is that values previously sent in the header when creating a contact (`source`, `storeExternalId`, `createAsUnapproved`) are now sent in the query string. If these are sent in the header in a v3 request, they will be ignored. ## Parameters There are three optional parameters that can be sent in the query string of your request. They are: This shows how the contact was created. Example values are “POS” or “e-com”. This is not mandatory, but highly recommended to reduce problems later on. The unique ID of the store or market where the customer signed up (also know as the recruited-by store). Often this is a numerical code like “600”. This parameter is not mandatory, but highly recommended to reduce problems later on. This creates an unverified contact which then must be verified by some other process or action, such as clicking a link in an email. It can have the string values “true” or “false”. An unverified contact like this will be ignored in reports and won’t be included in segmentations until specifically asked for. The default value is “false” so if you are not using this, you don’t need to worry about it. While it is possible to send in any `source` value you want in the query string, in order to filter contacts in Customer Engagement using a specific `source` value, that value needs to be added in the back-end by your Voyado team. Contact them to do this. Before you try to create a contact, always check first if they already exists. For this, use [this endpoint](/docs/contacts/identify-contact/find-contact) where multiple identifiers can be used to see if a contact is already in the database. ## Payload Here is the payload you will send in your create-contact request. You should specify the `contactType` in this payload. This needs to be a `contactType` that already exists. If you give one that doesn't exist, you'll get an error and no contact will be created. If the `contactType` is not specified in your payload, it defaults to "Member". ```json theme={null} { "firstName": "Example", "email": "example@example.com", "countryCode": "SE", "birthDay": "1966-06-26", "lang":"en", "contactType": "ExampleContactType", "preferences": { "acceptsEmail": true, "acceptsPostal": true, "acceptsSms": true }, "consents": [{ "id": "memberConsent", "value": true, "date": "2022-01-01T00:00:00+0100", "source": "ECOM", "comment": "Approved member terms at checkout" }] } ``` For countries using multiple languages the `lang` attribute is used. The field `birthDay`, if used, must have the format YYYY-MM-DD as in the example payload above. If it is used, the contact's age is calculated automatically when they are created. The value of `countryCode` is mostly used in segmentation to decide which language to use when communicating with an end-user. It is therefore important that `countryCode` is correct. When creating a contact, the recommended approach is to ONLY specify `countryCode` in the payload. The value for `country` will be automatically populated based on what you specify for `countryCode` (assuming you have sent a valid value). So do *not* include `country` in the payload. Your POS should have the option to easily update the end-user's `countryCode` when necessary. The field `countryCode` is not mandatory when creating a contact but it is highly recommended. ## Response payload After the POST operation, a new contact is created and their complete data set is returned. ```json theme={null} { "id": "e8f17b1d-b777-4688-862b-cf38009a726e", "attributes": { "firstName": "Example", "lastName": null, "street": null, "zipCode": null, "city": null, "email": "example@example.com", "mobilePhone": null, "countryCode": "SE", "careOf": null, "country": "Sweden", "age": 57, "birthDay": "1966-06-26", "externalId": null, "socialSecurityNumber": null, "gender": null, "staff": false, "memberNumber": "999032095", ... "currentStore": { "id": "b5e553d1-e4ba-40a0-8ee4-a9f631ee950b", "name": "Megashop E-commerce SE, 444", "externalId": "444" } }, "meta": { "createdOn": "2022-10-24T11:22:19+02:00", "modifiedOn": "2022-10-24T11:22:19+02:00", "sourceType": "API", "approved": true, "contactType": "ExampleContactType" }, "preferences": { "acceptsEmail": true, "acceptsPostal": true, "acceptsSms": true }, "consents": [{ "id": "memberConsent", "value": true, "date": "2022-01-01T00:00:00+0100", "source": "POS", "comment": "Approved member terms at checkout" }] } ``` For consents, only the fields `id` and `value` are mandatory. ## Endpoint timeout This endpoint has a significantly lower enforced timeout (under 10 seconds) compared to others in the API, and may return a *504 RequestTimeOut* status. This is intentional to ensure timely feedback in customer-facing flows like onboarding. If Customer Engagement returns a timeout on this endpoint, no contact will have been created and all internal operations will be rolled back. In this case, the integrating system should retry the request in accordance with the [Retry Policy](/docs/api/the-api#retry-policy), which provides guidance on recommended retry strategies. ## Response status codes A successful creation will return *HTTP 201 Created* along with the contact's data set as the response body (as shown above). If the request has failed, you'll get one of the following HTTP error codes: * *400 : NoData* * *409: ApprovedContactWithKeyExists, ContactWithKeyIsBeingCreated* * *422: ValidationError* * *504: RequestTimeOut* Don't send null or empty values in the JSON payload when updating or creating a contact. Empty values will override existing values. Send only what you want to change and nothing else. # Delete contact Source: https://developer.voyado.com/docs/contacts/delete-contact Deleting a contact in Customer Engagement is done through the /contacts endpoint using the `contactId`: ```http theme={null} DELETE /api/v3/contacts/[contactId] ``` In the query string you can send a `source` parameter to show how the contact was deleted. While it's not mandatory, it is useful for tracking the reason why contacts were deleted. This gives extra information about why the contact was deleted. Example values are "POS" or "e-com" but you can send anything else you want. There is no payload sent with this request. This endpoint is not to be used for batch deletion. For mass deletion of contacts, use the Customer Engagement UI or bulk integrations methods ([see this section](/docs/contacts/bulk-contacts-api)). ## **Responses** A successful deletion will return *HTTP 200 Ok*. If a contact with that ID could not be found, or was already deleted, you'll get *HTTP 404 Not Found*. # Deep linking to contacts Source: https://developer.voyado.com/docs/contacts/identify-contact/deep-linking It's possible to link directly to the contact card of a specific individual in the Customer Engagement frontend. This is called "deep linking". This saves many steps for customer agents when they need to search for a specific individual, or when they want to point someone else to a specific contact's details. The URL you will use has this form: ```http The URL form theme={null} https://[client].voyado.com/app#/contacts/contact-card/single/00000000-0000-0000-0000-000000000000/[contactId] ``` * **client:** Your specific client / tenant name (acme, megashop or whatever) * **contactId:** The contact ID for the contact you're linking to (GUID) Note that the "00000000-0000-0000-0000-000000000000" part is **required** for this to work. If you are using the Customer Engagement staging environment, this URL will have *staging* at the start: ```http The URL form in staging theme={null} https://[client].staging.voyado.com/app#/contacts/contact-card/single/00000000-0000-0000-0000-000000000000/[contactId] ``` You can now copy and share the URL you've created, allowing anyone who is logged into your Customer Engagement frontend to go directly to this contact's information. # Find a contact Source: https://developer.voyado.com/docs/contacts/identify-contact/find-contact Use this endpoint to check if a certain contact exists in Customer Engagement: ```http theme={null} GET /api/v3/contacts/id ``` To this endpoint you can send one (or several) of the following parameters in the query string: * email * socialSecurityNumber * mobilePhone * customKey ## Request examples As can be seen in the examples given below, parameters sent in a query string must always be *URL encoded*. ```http By email theme={null} GET /api/v3/contacts/id?email=john.doe%40gmail.com ``` ```http By socialSecurityNumber theme={null} GET /api/v3/contacts/id?socialSecurityNumber=196903027573 ``` ```http By mobilePhone theme={null} GET /api/v3/contacts/id?mobilePhone=%2B46735654321 ``` Although it's called "socialSecurityNumber" (sometimes SSN) in Customer Engagement, what's actually used here is a Swedish personal identity number, a Finnish personal identity code or a Swedish coordination numbers (samordningsnummer). ```http By customKey theme={null} GET /api/v3/contacts/id?customKey=999888777 ``` As the "customKey" value you can send either a contact's `memberNumber` or `externalId`, depending on how your tenant is set up. Your Voyado team can help you here. ## The any parameter The "any" parameter accepts any of the above values. To find a match, they are scanned using the value in the "any" parameter in this order: * email * socialSecurityNumber * mobilePhone * customKey The scanning of attributes will halt as soon as the given value passes validation for an attribute, even if that value returns no matches. So if a `customKey` is used with values that could validate as another attribute, for example as `mobileNumber`, then the scanning will stop with a *404 ContactNotFound* response and no match will be returned. A request would look like this: ```http A request using any theme={null} GET /api/v3/contacts/id?any=john.doe%40gmail.com ``` Or this: ```http Another request using any theme={null} GET /api/v3/contacts/id?any=999888777 ``` The `contactType` value can also be sent in the query string along with the above parameters but it is not required. ## Responses If the request has been successful, meaning the contact exists, you'll get a *HTTP 200 OK* response along with the contactId which is the unique identifier for your contact and looks something like this: `2e40b702-2767-4abe-ae99-aa510108e22b`. This `contactId` is what you will then use to fetch the contact's data. If the request has not been successful, you'll get one of the following HTTP error codes: * *400: InvalidEmailAddress, InvalidPhoneNumber, InvalidSocialSecurityNumber, InvalidContactType, InvalidSearchQuery* * *404: ContactNotFound* * *409: MultipleMatches* * *500: InvalidSystemConfiguration* Response codes could change, so always check your Swagger page to see the latest ones. ## Multiple responses It can happen that a search returns more than one `contactId`. For example, if you do a search with the `email` parameter and several contacts have supplied the same email, they will all be returned in that response. That will look like this: ```json Multiple matches response theme={null} { "errorCode": "MultipleMatches", "messageDetails": { "multipleMatchesFound": [ "1cdd503c-b8cf-1111-a001-b05b00c888a4", "2a361f42-f831-2222-852d-b0610100adef" ] }, "message": "Exception of type 'Voyado.Api.ApiException' was thrown.", "requestId": "f0930fe5-3333-4700-dddd-2ab2653ddf0c" } ``` For multiple matches, contact IDs are returned sorted by `CreationTime` and in ascending order. This means in the order in which they were created, with the earliest created coming first. # Get contact data Source: https://developer.voyado.com/docs/contacts/identify-contact/get-contact-data Once you have the `contactId` you can then fetch a contact's data. The recommended way to do this is: ```http Fetching data for contact theme={null} GET /api/v3/contacts/{contactId} ``` If you want the fetch the contact's full profile with the *extended data model*, see here: # Get enriched profile Source: https://developer.voyado.com/docs/contacts/identify-contact/get-enriched-profile Getting a contact's full information is core to Customer Engagement's power. It allows *personalization*, giving access to Customer Engagement's full customer profiling in a single request. This service has many use cases: * Populating an e-com My Pages or other landing page with customer information * Allowing a POS system to display the complete customer profile * Enabling the staff member to act on an incorrect email address * Informing the customer about reward vouchers or individual offers soon to expire * Allowing the e-com to switch content panels depending on customer's target audience This is all achieved through the `/contactoverview` endpoint. The data from this endpoint might contain cached contact information. For real-time updates on contacts and their corresponding data (promotions, reward points, etc.) then go directly to each entity endpoint, such as for example `/contacts/[contactId]/promotions`. The /contactoverview endpoint is not to be used as a contact lookup endpoint nor for ID-fetching. For this, use the other methods [described here](/docs/contacts/identify-contact/find-contact). Parameters sent in a query string must always be *URL encoded*. ## Using /contactoverview with contactId If you know the `contactId`, you can fetch a contact's data directly without using any other information. This is because `contactId` is guaranteed to always be unique for a contact, whereas this is not enforced for the the other personal identifiers. ```http theme={null} GET /api/v3/contactoverview?contactId={contactId} ``` You can also send `contactType` if you want, as shown here, but it's not mandatory in this case. ```http theme={null} GET /api/v3/contactoverview?contactType={contactType}&contactId={contactId} ``` ## Using /contactoverview with email With the email parameter, the `contactType` must also be sent. ```http theme={null} GET /api/v3/contactoverview?contactType=member&email=jane.doe%40gmail.com ``` ## Using /contactoverview with mobilePhone With the mobilePhone parameter, the `contactType` must also be sent. ```http theme={null} GET /api/v3/contactoverview?contactType=member&mobilePhone=%2B46702291216 ``` ## Using /contactoverview with socialSecurityNumber This is the Swedish personal identity number, Finnish personal identity code or Swedish samordningsnummer (coordination number). ```http theme={null} GET /api/v3/contactoverview?contactType=member&socialSecurityNumber=198506059738 ``` With the socialSecurityNumber parameter, the `contactType` must also be sent. ## Using /contactoverview with customKey As the customKey value you can send either a contact's `memberNumber` or `externalId`, depending on how your tenant is set up. Your Voyado Customer Engagement team can help you here. ```http theme={null} GET /api/v3/contactoverview?contactType=member&customKey=999888777 ``` With the customKey parameter, the `contactType` must also be sent. ## Using /contactoverview with any The "any" parameter will accept any of the above values. They are scanned in the following order: * email * socialSecurityNumber * mobilePhone * customKey For example: ```http theme={null} GET /api/v3/contactoverview?contactType=ecom&any=jane.doe%40gmail.com ``` Or: ```http theme={null} GET /api/v3/contactoverview?contactType=contact&any=999888777 ``` With the any parameter, the contactType must also be sent. Whenever you call /contactoverview with the `contactId`, sending `contactType` is optional. In all other cases, sending the `contactType` is mandatory. ## Response If the request has been successful, you'll get a *HTTP 200 OK* response along with the contact's data. Otherwise you'll get one of the following HTTP error codes: * *400: InvalidEmailAddress, InvalidPhoneNumber, InvalidSocialSecurityNumber, InvalidContactType, InvalidSearchQuery* * *404: ContactNotFound* * *409: MultipleMatches* * *500: InvalidSystemConfiguration* ```json theme={null} { "id": "33ee9958-0e09-484f-b4c4-aa3e00e1e24c", "attributes": { "firstName": "Example", "lastName": "Examplesson", "street": "Examplegatan 12", "zipCode": "123 45", "city": "Examplestad", "email": "example@example.com", "mobilePhone": "+46739111111", "countryCode": "SE", "socialSecurityNumber": "198101010101", "gender": "Female", "careOf": null, "country": "Sverige", "birthDay": "1981-01-01", "externalId": null, "memberNumber": "999888777", "rfm": 46, "children": [ "2007-11-28T00:00:00+01:00" ], "age": 35, "registrationDate": "2019-02-05T13:21:02+01:00", "secrecyMarked": false, "currentStore": { "id": "0b7037b4-b7f5-4c9d-97e6-aa3b00ccc140", "name": "Rotterdam", "externalId": "SE014" } }, "meta": { "createdOn": "2019-04-29T15:42:25+02:00", "modifiedOn": "2020-05-31T04:02:27+02:00", "sourceType": "Import", "approved": true, "contactType": "Member", "recruitedByStore": { "id": "a9573a5a-c9bb-4593-abee-aa3b00ccc141", "name": "Nice", "externalId": "SE019" } }, "preferences": { "acceptsEmail": true, "acceptsPostal": true, "acceptsSms": true }, "tiers": { "expires": null, "tierName": "Bas", "remainingToUpgrade": 233, "basedOnPoints": 767, "tierId": "bas" }, "consents": [ { "id": "consentIntelligentOffers", "value": true, "date": "2019-05-06T14:00:51+02:00", "comment": "", "source": "ContactForm" }, { "id": "consentSegmentation", "value": true, "date": "2019-05-06T14:00:51+02:00", "comment": "", "source": "ContactForm" }, { "id": "consentGeneralTerms", "value": true, "date": "2019-05-06T14:00:51+02:00", "comment": "", "source": "ContactForm" } ], "audiences": [ "Best Customers rolling 24 months", "My VIP Group", "Intergamma VIP", "Superbokare" ], "warnings": [ "MissingMobileNumber" ], "rewardVouchers": [ { "expiresOn": "2020-08-31T23:59:59+02:00", "id": "880adf9c-b70b-47a8-b746-aaf900528332", "voucherNumber": "0000000000161", "name": "Generate reward vouchers 02/11/2019 08:00", "value": { "currency": "EUR", "amount": 3 }, "localValues": [ { "currency": "SEK", "amount": 30 }, { "currency": "NOK", "amount": 30 } ], "points": 100, "redeemed": false, "redeemedOn": null } ], "promotions": [ { "id": "27c03506-89d6-4023-a158-c0bb0dc09e58", "externalId": null, "type": "Multichannel", "name": "Spring Campaign", "expiresOn": null, "heading": "Spring Campaign", "description": "Dear customer, The spring is here, time for updating your wardrobe! Please enjoy the following spring time promotion. With love", "redeemed": false, "redeemedOn": null, "imageUrl": null, "link": null, "redemptionChannels": [ { "id": "75992b07-b287-4417-8cb8-adba010fdaf8", "externalId": null, "type": "Multichannel", "name": "20% off VIP offer!", "expiresOn": null, "heading": null, "description": null, "redeemed": false, "redeemedOn": null, "imageUrl": null, "link": null, "redemptionChannels": [ { "type": "POS", "valueType": "PERCENT", "value": 20, "instruction": null }, { "type": "ECOM", "valueType": "EXTERNALOFFER", "value": "VIP20PERCENT", "instruction": null } ] } ] } ``` ## Changes going from API v2 to v3 Changes were made to this endpoint for API v3. One important change to note is that in v3 a contact's total points (bonus points) are no longer returned from `/contactoverview`. For v3, this can only be done through a separate GET request to the already existing but slightly changed /point-accounts endpoint. See here for more: # Soft identification Source: https://developer.voyado.com/docs/contacts/identify-contact/soft-identification Soft identification, sometimes called "soft login" or "soft ID", allows identification of a contact who has arrived at a webpage via an email link. When your Customer Engagement environment is configured for soft identification, an encrypted JSON is sent in the link's query string, which has the following form: ```javascript theme={null} eclub=q6KCtl2WUiWxd5UzDMcfKNuZonZ6bVx7LZm2y8ctNJVJm4Oiyz339wWMIuVAzHIwikEdtDFYllMLwMhMZ4GTn55SBGjSn2ZQsDtCEDJ-zG7ptW6hC9n2UO2NVxaijERvURtBPFIE35EZPPSk_PAZHmQp72C0N6-h1xgfok9lb-9IV_hWorlegR8sD64p3SOy ``` In this data is contained all the information needed to identify the contact and present them with a personalized web experience. When decrypted, the JSON has the following structure: ```json theme={null} { "contactId": "1c9b35d6-28d8-4520-8900-a89555f7f0c5", "email": "example@example.com", "dateTime": "2018-07-11T11:19:54Z", "discoveryKey" : "6iub35d6-34d8-6666-8900-e89100f7f0c5" } ``` * **contactId:** The unique ID for the contact in Customer Engagement, used for subsequent API-calls to get all relevant information about a contact * **email:** The contact's email address * **id:** The contact's identification key as defined in Customer Engagement (for example, "email") * **dateTime:** The time and date the link was generated (V.5) * **discoveryKey:** The contact's identifier for Voyado Product Discovery (optional) To include the `discoveryKey` from Voyado Product Discovery, ask your Voyado team to set it up for you. Be careful about the access a user is granted via a soft login. A soft login link is a convenient method of identification but it can also be easily shared in error, for example by a user forwarding an email containing the link to a friend. ## Decoding the message Extract the value string from the parameter “eClub” Decoding the string from URL-safe Base64": * Replace all “-” with “+” * Replace all “\_” with “/” * Add padding characters, based on the length * Decode the string using normal Base64 decoding The initialization vector is stored in the first 16 bytes; the remainder is the encoded message" With the shared key and initialization vector from step 3, decrypt the message using AES-256 (CBC) ## Encoding the message The data is sent as a JSON with the structure shown in the example above. This JSON string is then encrypted using AES-256 and the shared key which both the customer and Voyado have (it was exchanged during implementation) and a unique initialization vector for each message. The initialization vector and the encrypted string are concatenated, Base64 encoded and modified for URL inclusion (URL-safe Base64). The complete encoded string is then sent as the query-string parameter “eClub”. The shared key used is 32 characters long, using no special characters, only a-z, A-Z, 0-9. An example of such a key is: `DaqfT7Ys6tGqM3zbesEKpmacTJEqBCp2`. There are online tools available for creating keys, such as [Strong Random Password Generator](https://passwordsgenerator.net/). ```csharp theme={null} public static string Decrypt(string keyString, string stringToDecrypt) { var key = Encoding.UTF8.GetBytes(keyString); stringToDecrypt = stringToDecrypt.Replace('-', '+').Replace('_', '/'); switch (stringToDecrypt.Length % 4) { case 2: stringToDecrypt += "=="; break; case 3: stringToDecrypt += "="; break; } var bytes = Convert.FromBase64String(stringToDecrypt); var iv = new byte[16]; var text = new byte[bytes.Length - 16]; Array.Copy(bytes, iv, 16); Array.Copy(bytes, 16, text, 0, text.Length); string plaintext = null; using (var aes = Aes.Create()) { aes.Padding = PaddingMode.PKCS7; aes.IV = iv; aes.Key = key; aes.Mode = CipherMode.CBC; var decryptor = aes.CreateDecryptor(aes.Key, aes.IV); using (var msDecrypt = new MemoryStream(text)) { using (var csDecrypt = new CryptoStream(msDecrypt, decryptor, CryptoStreamMode.Read)) { using (var srDecrypt = new StreamReader(csDecrypt)) { plaintext = srDecrypt.ReadToEnd(); } } } } return plaintext; } ``` ```perl theme={null} use Crypt::Mode::CBC; use MIME::Base64::URLSafe; my $key = 'THE SHARED KEY'; my $input = 'THE ENCRYPTED VALUE'; $input = urlsafe_b64decode($input); my $iv = substr($input, 0, 16); my $data = substr($input, 16); my $cbc = Crypt::Mode::CBC->new('AES'); my $decrypted = $cbc->decrypt($data, $key, $iv); ``` ```php theme={null} function decrypt($key, $encrypted) { $encrypted = base64_decode(strtr( $encrypted, '-_', '+/') . str_repeat('=', 3 - ( 3 + strlen( $encrypted )) % 4 )); $iv = substr($encrypted, 0, 16); $encrypted = substr($encrypted, 16); $decrypted = openssl_decrypt($encrypted,'aes-256-cbc',$key,OPENSSL_RAW_DATA, $iv); return $decrypted; } ``` ```javascript theme={null} const crypto = require('crypto'); const stringToDecrypt = "INSERT STRING TO DECRYPT HERE"; const keyString = "INSERT KEY HERE"; const key = Buffer.from(keyString, 'utf8'); let stringToDecryptFixed = stringToDecrypt.replace('-', '+').replace('_', '/'); switch (stringToDecryptFixed.length % 4) { case 2: stringToDecryptFixed += "=="; break; case 3: stringToDecryptFixed += "="; break; } const bytes = Buffer.from(stringToDecryptFixed, 'base64'); const iv = Buffer.alloc(16); const text = bytes.slice(16); bytes.copy(iv, 0, 0, 16); let plaintext = null; const decipher = crypto.createDecipheriv('aes-256-cbc', key, iv); decipher.setAutoPadding(false); plaintext = Buffer.concat([decipher.update(text), decipher.final()]).toString('utf-8'); console.log(plaintext); ``` # NPS Source: https://developer.voyado.com/docs/contacts/nps NPS stands for *Net Promoter Score*. This is a common metric used in customer experience programs. A customer's NPS measures a customer's loyalty by looking at how likely they are to recommend a given business. It is given as an number on a scale of 1 to 10. The NPS endpoint is only available in the Customer Engagement v3 API. ## Adding NPS for contact An NPS score can be added for a specific contact using the following v3 endpoint: ```http theme={null} POST /api/v3/contacts/{contactId}/createNpsResponse ``` Unique identifier of the contact, added in the path as shown. Sent in query string. The actual NPS value for this contact, from 1 - 10. An example request would then be: ```http Example request theme={null} POST /api/v3/contacts/2e40b702-2767-4abe-ae99-aa510108e22b/createNpsResponse?grade=5 ``` ## Responses The possible responses from this request are: * *200 OK*: The POST was successful and the NPS value was saved for the contact. * *400* InvalidGrade: The grade value was missing or not in the allowed range. * *404* ContactNotFound: No contact was found with the given `contactId`. # Security best practices Source: https://developer.voyado.com/docs/contacts/security-best-practices Using open web forms to add contacts to a database comes with inherent risks. These range from malicious attacks that exploit vulnerabilities to attempts to disrupt businesses. Here you'll see how to mitigate these kinds of risks and uphold the integrity and security of your Customer Engagement account. ## **Open sign-up forms and the Customer Engagement API** Access to the Customer Engagement API using your API key should, like any online service, be handled in a safe and secure way. For example, if you have created an open online sign-up form, this could be abused by a malicious actor to register non-existing contacts. And as long as the sign-ups from that form don't exceed the API's rate limit, Customer Engagement then has no way to tell that these are not legitimate contacts. This clearly causes other problems, such as polluting your contact pool with fake accounts, skewing your BI reports, and opening the possibility of sending out SMS to these fake contacts (if you have set up automations to do this) which can incur actual costs. Therefore this safety aspect needs to be considered and planned for. ## **Mitigating the risks** Here's how to think, prepare and act concerning these kinds of risks. ### **Identify the entry points** Start by identifying all the various entry points that malicious entities can exploit, including custom-built forms, API integrations, and third-party tools used for data collection. ### **Minimize the influx of bad entries** * Keep an eye on your **contact database growth** in the Customer Engagement dashboard or through reports. This will allow you to spot abnormal growth rates in your database. * Implement **data validation techniques** to verify the authenticity of personal information and data points. [See the contact field definitions](/docs/contacts/contact-field-definitions). * Use **unique identifiers**, such as email addresses and mobile phone numbers, to prevent duplication of contacts and enforce data integrity. Check with your Voyado team to ensure that those identifiers are actually set to be unique in your Customer Engagement environment. * **Cross-reference** new contact registration with those already existing to detect potential duplicates or suspicious entries. [See this article on identifying contacts](/docs/contacts/identify-contact/find-contact). * Implement **CAPTCHA mechanisms and double opt-in processes** ([see more here](https://help.engage.voyado.com/hc/en-gb/articles/17253837916316-Working-with-double-opt-in)) to add an additional layer of security and verification for sign-ups. ### **Reduce the costs of bad SMS send-outs** * Implement a **whitelist** on registration forms to validate phone numbers based on specified country codes. This will reduce the likelihood of sending SMS to erroneous or international numbers. Ask your Voyado team to help you configure this. * Use **segmentation** in automation processes to target specific audiences, which minimizes the risk of unnecessary SMS dispatches. * Consider buying **prepaid packages of SMS messages**, creating a ceiling on the number that can be sent out per month. This helps minimize losses in the event of a malicious incident. ## **Summary** By sticking to these best practices and being vigilant about potential security threats, you can maintain the integrity of your contact database. Proactive measures, coupled with continuous monitoring and adaptation, are key to mitigating these risks and ensuring a secure onboarding and contact creation process. # Target audiences Source: https://developer.voyado.com/docs/contacts/target-audiences One way of grouping your contacts in Customer Engagement is with **target audiences**. A target audience is a grouping of contacts that's recalculated on a fixed schedule (every night is standard). The contacts in a target audiences can therefore change from day to day. For example, some people will be having a birthday, some will have made their first purchase, some might have just moved to Limerick, and others might have just left Limerick, vowing never to return. Every contact can belong to many different target audiences. Other ways of grouping contacts are by **segmentation** (an on-the-fly grouping based on the current state of all contacts) and **labels** (a more static way of grouping since, once given a label, a contact will have it until it is removed). ## **Fetching target audiences** With target audiences you can profile your customers more strategically, using them as building blocks for your day-to-day campaigning, and building up a library of target audiences based on life cycle stages, personas, geographic location, product category affinity, or whatever is of interest. You can also expose these audiences in external applications, for example to further personalize a customer's experience in a sales situation in stores or online. To do this, you'll need to know which audiences exist in your Customer Engagement instance. To fetch all target audiences in your Customer Engagement instance, use this endpoint: ```http theme={null} GET /api/v3/target-audiences ``` There are no parameters or payload required in this request. ## **Structure of response** A successful request gives a **HTTP 200** response along with data in this format: ```json Target audiences response theme={null} [ { "id": "91a2ea56-c08b-48fe-b510-ffff006aedde", "name": "Svenska medlemmar" }, { "id": "5b195078-0f72-4206-ac1a-aaaa006ce19e", "name": "Silver" }, { "id": "1ef5e951-a0f1-4822-b69e-cccc006cf38a", "name": "Member" } ] ``` Each JSON object in this array represents a target audience: The unique ID for that target audience. Currently not useful, but a future endpoint could be used to return all the contacts in this target audience using this ID. The name of the target audience as entered when the audience was created. If you need to fetch all the target audiences that a specific contact belongs to, you can do it using the [contact overview endpoint](/docs/contacts/identify-contact/get-enriched-profile). # Update contact Source: https://developer.voyado.com/docs/contacts/update-contact Updating the details of a Voyado Customer Engagement contact is done through the /contacts endpoint using their unique `contactId` and the PATCH method: ```http theme={null} PATCH /api/v3/contacts/{contactId} ``` If you don’t have the `contactId`, [you can get it using other contact attributes.](/docs/contacts/identify-contact/find-contact) This PATCH endpoint is to be used for single contact updates. Do NOT use it for bulk updates of contacts. In that case, use the [bulk methods provided](/docs/contacts/bulk-contacts-api). When you have the `contactId` you call the endpoint like this: ```http theme={null} PATCH /api/v3/contacts/430d3329-7eef-45c0-37f9-ae9300a0daceid ``` As the payload, send ONLY the attributes that you want to change: ```json theme={null} { "lastName": "Examplesson", "street": "New Street 1337" } ``` In this example, the contact has changed their surname and moved to a new address. These attributes will be updated. When updating contacts over the API be sure to ONLY send the fields you want to update and nothing else. This applies for individual as well as bulk updates. Any empty fields added to your update payload (string.Empty, null, "", etc.) will overwrite the current values on the contact. You can't use this endpoint to update a contact's contact type. This has to be done using the `/contacts/[contactId]/updateContactType` endpoint. See the next section. ## Changing contact type To update `contactType` to "Member" or to another value, you will use this endpoint: ```http theme={null} POST /api/v3/contacts/{contactId}/updateContactType?contactTypeId=Member ``` In this example we are changing the contact's type to "Member". Be aware that the `contactId` is not changed when you change the `contactType`. This endpoint is the only way to update a contact's `contactType`. If you try to use the PATCH method shown above to change `contactType` it will not work. ## Don't send empty values You need to be careful to never send empty values in the JSON payload when updating a contact. If a field exists in the payload, Customer Engagement will use that value and overwrite the existing one. For example, if a contact's last name isn’t added in the POS, do *not* add that field to the payload. ```json DO NOT DO THIS! theme={null} { "firstName": "Example", "lastName": "", "street": "Big Street 1234" } ``` In this case, the current value of lastName will be overwritten by an empty string. You probably don't want this. Instead, do this: ```json This is how to do it theme={null} { "firstName": "Example", "street": "Big Street 1234" } ``` Note also that a field which does not exist in the contact's data will be ignored and no error will be returned. This means it is important to make sure you are sending the right name for each field. ```json This update will be ignored theme={null} { "firstNam": "Example", } ``` ## Responses A successful update will return *HTTP 200 Ok* along with the contact's new data. If the request has failed, you'll get one of the following HTTP error codes: * *400 : NoData* * *404: Not Found* # Introduction to BI Export Source: https://developer.voyado.com/docs/data-access/bi-export BI Export delivers your Customer Engagement data as *structured CSV files on your FTP server*. The data is cleaned, curated, and organized into ready-to-use exports. You don't need to build ingestion logic or transform the data yourself before analyzing it. ## What is an export? An **export** is a flat-file dataset for a single entity in Customer Engagement, delivered as CSV files. For example: * The "Receipt" export is one file with a list of all transaction headers * The "Message" export is one file with a list of all messages and their settings * The "Contact" export provides a list of all contacts in your Customer Engagement environment delivered as one file per contact type Some important points about exports: * Each export runs independently and produces its own file (or files). * Exports are performed once per day, during the night. * The exac
[...]
